import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["as", "children", "fullWidth", "size", "design", "negative", "groupPositions", "onClick"];
import { Children } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import { atomButtonDesigns, atomButtonSizes } from '@s-ui/react-atom-button';
import Injector from '@s-ui/react-primitive-injector';
import Poly from '@s-ui/react-primitive-polymorphic-element';
import { BASE_CLASS } from './settings.js';
import { jsx as _jsx } from "react/jsx-runtime";

var getGroupPosition = function getGroupPosition(_ref) {
  var groupPositions = _ref.groupPositions,
      numChildren = _ref.numChildren;
  return function (index) {
    if (index === 0) return groupPositions.FIRST;
    if (index === numChildren - 1) return groupPositions.LAST;
    return groupPositions.MIDDLE;
  };
};

var MoleculeButtonGroup = function MoleculeButtonGroup(_ref2) {
  var _ref2$as = _ref2.as,
      as = _ref2$as === void 0 ? 'div' : _ref2$as,
      children = _ref2.children,
      fullWidth = _ref2.fullWidth,
      size = _ref2.size,
      design = _ref2.design,
      negative = _ref2.negative,
      groupPositions = _ref2.groupPositions,
      onClick = _ref2.onClick,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded);

  var numChildren = children.length;
  var getGroupPositionByIndex = getGroupPosition({
    groupPositions: groupPositions,
    numChildren: numChildren
  });
  var extendedChildren = Children.toArray(children).filter(Boolean).map(function (child, index) {
    var groupPosition = getGroupPositionByIndex(index);
    return /*#__PURE__*/_jsx(Injector, _extends({}, props, {
      negative: negative,
      size: size,
      design: design,
      groupPosition: groupPosition,
      fullWidth: fullWidth,
      onClick: onClick,
      children: child
    }));
  });
  return /*#__PURE__*/_jsx(Poly, {
    className: cx(BASE_CLASS, fullWidth && BASE_CLASS + "--fullWidth"),
    children: extendedChildren
  });
};

MoleculeButtonGroup.displayName = 'MoleculeButtonGroup';
MoleculeButtonGroup.defaultProps = {
  groupPositions: {
    FIRST: 'first',
    MIDDLE: 'middle',
    LAST: 'last'
  }
};
export default MoleculeButtonGroup;
export { atomButtonDesigns as moleculeButtonGroupDesigns, atomButtonSizes as moleculeButtonGroupSizes };